// MaiFile.h: CMaiFile NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "DataDateTime.h"
#include "idbfile.h"
#include "ProgressBar.h"
#include "CalcFile.h"

class CMaiFile  
{
public:
	CMaiFile();
	virtual ~CMaiFile();

public:
	long	m_StartYY;	// JnFN
	long	m_StartMM;	// JnF
	long	m_StartDD;	// JnF
	long	m_StartMS;	// JnFmb
	int		m_RsuId;	// RSU ID
	int		m_NetworkId;// lbg[NID
	int		m_SensorId;	// ZT[ID
	double	m_SampleRate;	// Tv[g
	int		m_CntPerHour;	// PԂ̃f[^
	int		m_Cutofff;	// JbgItg
	int		m_Offset;	// ItZbg
	CString m_maiFname;	// mait@CiPATHȂj
	CStringArray	m_BinName0;	// `lNo0BINt@CۑGA
	CStringArray	m_BinName1;	// `lNo1BINt@CۑGA
	CStringArray	m_BinName2;	// `lNo2BINt@CۑGA
	CStringArray	m_BinName3;	// `lNo3BINt@CۑGA
	CString m_ConvDataPath;	// Hwlϊf[^݃tH_
	// IDBt@C
	CIdbFile m_Idb;
	CDataDateTime m_In_startTime;
	CStringArray	m_Name;		// wtH_ɑ݂SĂmait@CۑGA

private:
	CStringArray	m_maiDat;	// mait@C̓eSēǂݍރGA
// update 2008/03/18 by hama@
	CStringArray	m_Rsu;	// mait@CRSUۑGA
// update 2008/03/18 by hama@
	CArray<long, long> m_Samples0;	// 0t@C̃f[^
	CArray<long, long> m_Samples1;	// 1t@C̃f[^
	CArray<long, long> m_Samples2;	// 2t@C̃f[^
	CArray<long, long> m_Samples3;	// 3t@C̃f[^
	long	m_Total0;	// 0t@C̃f[^
	long	m_Total1;	// 1t@C̃f[^
	long	m_Total2;	// 2t@C̃f[^
	long	m_Total3;	// 3t@C̃f[^
	CString m_WorkPath;	// t@C݃tH_
	CString	m_path;		// ݃tH_pX
	long	m_Start_msec;
	long	m_End_msec;
	// HwlϊNX|C^
	CCalcFile* m_CalcFile;

public:
	int ReadMaiFile(LPCSTR path, CDataDateTime * start, CDataDateTime * end);
	int ReadMaiFile2(LPCSTR maiPath, BOOL bDispErrMsg);
	void ResetData(void);
	BOOL WriteData(LPCSTR p_path, long Start_msec, long End_msec);
	// Hwlf[^݃tH_쐬
	int mkDir(LPCSTR pos, LPCSTR category, LPCTSTR measurement_kind);
	// BINt@C̃wb_IDBɕۑ
	void GetBinInfo(LPCSTR fname);
	BOOL GetItems();
	void GetStartEnd(CDataDateTime *start, CDataDateTime *end);

private:
	int GetMaiFileName(LPCSTR path);
// update 2008/03/18 by hama@
	int GetRsuFromMaiFileName(void);
	bool IsRsu(LPCSTR sen);
// update 2008/03/18 by hama@
	bool GetMaxMaiFileName(CString &fname, CString Sensor);
	int GetMaFileiData(LPCSTR path);
	bool GetDataFromMai(LPCSTR dat, LPCSTR itemStr, CString& oDat);
	bool FuriwakeBinFileName(void);
	int GetChNoFromFName(LPCSTR fname);
	int DelSameName(void);
	void SortArr(void);
	void RecalcTotal(void);
	bool GetStartTime(void);
	bool GetStartYMDmS(LPCSTR str, long * YY, long * MM, long * DD, long * mS);
	bool GetUnitID(void);
	bool GetSensorID(void);
	bool GetSampleRate(void);
	BOOL WriteKetugouFile(CProgressBar* pProgressBar);
	BOOL WriteCalcData(CProgressBar* pProgressBar);
	static	BOOL WriteDataThread(LPVOID pParam, CProgressBar* pProgressBar);
	static	BOOL WriteDataThread2(LPVOID pParam, CProgressBar* pProgressBar);
};
